% demo.m

%% clear all
clc; clear; close all;

%%
addpath('jpegtbx_1.4');
addpath('measures');

%% image information
q = 50; imgname = 'ucid00278.pgm';
jpgname = [imgname(1:length(imgname)-4),'-',num2str(q,'%.2d'),'.jpg'];
tvdbkname = [jpgname(1:length(jpgname)-4),'_icassp13dbk.pgm'];
forgname = [jpgname(1:length(jpgname)-4),'_icassp13.pgm'];

%% read image
I = double(imread(imgname));
jpgI = double(imread(jpgname));
jobj = jpeg_read(jpgname);
Q = jobj.quant_tables{1};
dctQCoefs = dequantize(jobj.coef_arrays{1},Q);

fprintf('\n%s\n',jpgname);
fprintf('%10.4f %10.4f %10.4f %10.4f %10.4f %10.4f\n',psnr(I,I),ssim(I,I),cali_feature(I),blk_measure(I),blk_grad_measure(I,1),blk_grad_measure(I,2));
fprintf('%10.4f %10.4f %10.4f %10.4f %10.4f %10.4f\n\n',psnr(jpgI,I),ssim(jpgI,I),cali_feature(jpgI),blk_measure(jpgI),blk_grad_measure(jpgI,1),blk_grad_measure(jpgI,2));

%% TV-based deblocking
lambda = 1.5; iterN = 50; steps = 1./(1:iterN);
tvI = TVsubGradJPEGAnti4N6(jpgI,dctQCoefs,Q,lambda,iterN,steps);
% imwrite(uint8(tvI),tvdbkname);
fprintf('%10.4f %10.4f %10.4f %10.4f %10.4f %10.4f\n\n',psnr(tvI,I),ssim(tvI,I),cali_feature(tvI),blk_measure(tvI),blk_grad_measure(tvI,1),blk_grad_measure(tvI,2));

%% de-calibration
caliT =  0.07;
caliI = deCalibration(tvI,caliT);
imwrite(uint8(caliI),forgname);

%% print the results
fprintf('%10.4f %10.4f %10.4f %10.4f %10.4f %10.4f\n',psnr(caliI,I),ssim(caliI,I),cali_feature(caliI),blk_measure(caliI),blk_grad_measure(caliI,1),blk_grad_measure(caliI,2));